'use strict';

// Default bootstrap column count

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var COLUMN_COUNT = 12;
var INPUT_LENGTH_THRESHOLD = 50;
var DATETIME_NUMBER_FORMAT = 'x';

var FORM = 'http://onto.fel.cvut.cz/ontologies/documentation/form',
    HAS_SUBQUESTION = 'http://onto.fel.cvut.cz/ontologies/documentation/has_related_question',
    HAS_ANSWER = 'http://onto.fel.cvut.cz/ontologies/documentation/has_answer',
    HAS_OPTION = 'http=//onto.fel.cvut.cz/ontologies/form/has-possible-value',
    HAS_OPTIONS_QUERY = 'http://onto.fel.cvut.cz/ontologies/form/has-possible-values-query',
    HAS_VALUE_TYPE = 'http://onto.fel.cvut.cz/ontologies/form/has-value-type',
    IS_DISABLED = 'http://onto.fel.cvut.cz/ontologies/aviation/form-376/is-disabled',
    LAYOUT_CLASS = 'http://onto.fel.cvut.cz/ontologies/form-layout/has-layout-class',
    LAYOUT = {
    FORM: 'form',
    QUESTION_TYPEAHEAD: 'type-ahead',
    QUESTION_SECTION: 'section',
    WIZARD_STEP: 'wizard-step',
    DISABLED: 'disabled',
    HIDDEN: 'hidden',
    TEXTAREA: 'textarea',
    NUMBER: 'number',
    DATE: 'date',
    TIME: 'time',
    DATETIME: 'datetime',
    CHECKBOX: 'checkbox',
    ANSWERABLE: 'answerable'
},
    VALUE_TYPE_CODE = 'code',
    VALUE_TYPE_TEXT = 'text',
    GENERATED_ROW_SIZE = 1,
    HAS_QUESTION_ORIGIN = 'http://onto.fel.cvut.cz/ontologies/form/has-question-origin',
    HAS_ANSWER_ORIGIN = 'http://onto.fel.cvut.cz/ontologies/form/has-answer-origin',
    HAS_DATA_VALUE = 'http://onto.fel.cvut.cz/ontologies/documentation/has_data_value',
    HAS_OBJECT_VALUE = 'http://onto.fel.cvut.cz/ontologies/documentation/has_object_value';

/**
 * Contains mainly definition of constants used to parse the form declaration.
 */

var Constants = function () {
    function Constants() {
        (0, _classCallCheck3.default)(this, Constants);
    }

    (0, _createClass3.default)(Constants, null, [{
        key: 'COLUMN_COUNT',
        get: function get() {
            return COLUMN_COUNT;
        }
    }, {
        key: 'INPUT_LENGTH_THRESHOLD',
        get: function get() {
            return INPUT_LENGTH_THRESHOLD;
        }
    }, {
        key: 'DATETIME_NUMBER_FORMAT',
        get: function get() {
            return DATETIME_NUMBER_FORMAT;
        }
    }, {
        key: 'FORM',
        get: function get() {
            return FORM;
        }
    }, {
        key: 'HAS_SUBQUESTION',
        get: function get() {
            return HAS_SUBQUESTION;
        }
    }, {
        key: 'HAS_ANSWER',
        get: function get() {
            return HAS_ANSWER;
        }
    }, {
        key: 'HAS_OPTION',
        get: function get() {
            return HAS_OPTION;
        }
    }, {
        key: 'HAS_OPTIONS_QUERY',
        get: function get() {
            return HAS_OPTIONS_QUERY;
        }
    }, {
        key: 'HAS_VALUE_TYPE',
        get: function get() {
            return HAS_VALUE_TYPE;
        }
    }, {
        key: 'IS_DISABLED',
        get: function get() {
            return IS_DISABLED;
        }
    }, {
        key: 'LAYOUT_CLASS',
        get: function get() {
            return LAYOUT_CLASS;
        }
    }, {
        key: 'LAYOUT',
        get: function get() {
            return LAYOUT;
        }
    }, {
        key: 'VALUE_TYPE_CODE',
        get: function get() {
            return VALUE_TYPE_CODE;
        }
    }, {
        key: 'VALUE_TYPE_TEXT',
        get: function get() {
            return VALUE_TYPE_TEXT;
        }
    }, {
        key: 'GENERATED_ROW_SIZE',
        get: function get() {
            return GENERATED_ROW_SIZE;
        }
    }, {
        key: 'HAS_QUESTION_ORIGIN',
        get: function get() {
            return HAS_QUESTION_ORIGIN;
        }
    }, {
        key: 'HAS_ANSWER_ORIGIN',
        get: function get() {
            return HAS_ANSWER_ORIGIN;
        }
    }, {
        key: 'HAS_DATA_VALUE',
        get: function get() {
            return HAS_DATA_VALUE;
        }
    }, {
        key: 'HAS_OBJECT_VALUE',
        get: function get() {
            return HAS_OBJECT_VALUE;
        }
    }]);
    return Constants;
}();

exports.default = Constants;